[uwsgi]
############################
### Generic UWSGI config ###
############################

# Override the default size for headers from the 4k default.
buffer-size = 65535

# This avoids error 104: "Connection reset by peer"
rem-header = Content-Length

# This is running standalone
master = true

# uwsgi recommends this to prevent thundering herd on accept.
thunder-lock = true

plugins = python3

# This ensures that file descriptors aren't shared between the WSGI application processes.
lazy-apps = true

# Log from the wsgi application: needs python3-pastescript as runtime depends.
paste-logger = true

# automatically kill workers if master dies
no-orphans = true

# exit instead of brutal reload on SIGTERM
die-on-term = true

# Avoid memcached connections to remain opened
close-on-exec = true
close-on-exec2 = true

##########################
### Performance tuning ###
##########################
# Threads and processes
enable-threads = true

# For max perf, set this to number of core*2
processes = 8

# This was benchmarked as a good value
threads = 32

# This is the number of sockets in the queue.
# It improves a lot performances. This is comparable
# to the Apache ServerLimit/MaxClients option.
listen = 100

##################################
### OpenStack service specific ###
##################################

# These are used in the gate.
# The http-auto-chunked / http-chunked-input
# are mandatory, specific to Cinder, and are
# the reasons why Glance doesn't work on Apache
socket-timeout = 10
http-raw-body = true
chmod-socket = 666
lazy-apps = true
add-header = Connection: close
enable-threads = true
exit-on-reload = true
die-on-term = true
wsgi-manage-chunked-input = true

# This is the standard port for the WSGI application, listening on all available IPs
logto = /var/log/cinder/cinder-api.log
name = cinder-api
uid = cinder
gid = cinder
chdir = /var/lib/cinder
wsgi-file = /usr/bin/cinder-wsgi

# This is controled by the init script using the --http-socket
# or using the --https thing. https will be activated if a file
# /etc/cinder/ssl/private/*.pem is found. In both case, port 9292
# on all IPs will be used.
# The partern to search for the private key file is:
# find /etc/cinder/ssl/private -type f -iname '*.pem' | head -n 1
# and for the certificate:
# find /etc/cinder/ssl/private -type f -iname '*.crt' | head -n 1
# just drop files there and restart the daemon, and you'll have
# SSL up and running.
#http-socket = :8776
#https 0.0.0.0:8776,foobar.crt,foobar.key
